#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "addressbook.h"

ABOOK abook;

void clean_spaces(char *s)
{
    char tmp[200];
    int i, j;
    strcpy(tmp, s);

    /** skip initial spaces */
    for (i=0; i<strlen(tmp); i++) 
        if (isspace(tmp[i])) continue;
        else break;
    
    for (j=0; i<strlen(tmp); i++, j++) 
        s[j] = tmp[i];
    s[j] = 0;

    for (j=strlen(s)-1; j>=0; j--) {
        if (isspace(s[j])) s[j] = 0;
    }
}

int main(int argc, char *argv[])
{
    if (argc < 2) {
        printf("Usage: %s <filename> \n", argv[0]);
        exit(-1);
    }
    FILE *f = fopen(argv[1], "r");
    char s[50]; 

    while (!feof(f)) {
        ABOOK_ENTRY entry;
        fgets(entry.name, 49, f);
        if (feof(f)) break;
        clean_spaces(entry.name);
        fgets(entry.address, 99, f);
        entry.address[strlen(entry.address)-1] = 0;
        fgets(entry.telephone, 19, f);
        entry.telephone[strlen(entry.telephone)-1] = 0;
        abook_insert(&abook, &entry);
    }
    abook_print(&abook);
    
    int quit = 0; 
    while (!quit) {
        printf("Insert Name to search: ");
        scanf("%s", s);
        if (strcmp(s, "quit") == 0) break;
        else {
            printf("Name to search: XX%sXX\n", s); 
            ABOOK_ENTRY e = abook_search(&abook, s);
            printf("Result: \n");
            abook_entry_print(&e);
        }
    }
    return 0;
}
