#include <stdio.h>
#include <stdlib.h>

#include "list.h"

void list_error(char *msg)
{
    printf("%s", msg);
    exit(-1);
}

void list_init(LIST *l)
{
    l->head = 0;
    l->nelem = 0;
}

void list_insert_h(LIST *l, int d)
{
    LNODE *p = (LNODE *)malloc(sizeof(LNODE));
    p->dato = d;
    p->next = l->head;
    l->head = p;
}

void list_insert_t(LIST *l, int d)
{
    LNODE *q = (LNODE *)malloc(sizeof(LNODE));
    q->dato = d;
    q->next = 0;
    
    LNODE *p = l->head;
    // caso particolare: lista vuota
    if (p == 0) l->head = q;
    else {
        // scorri fino all'ultimo elemento
        while (p->next != 0) p = p->next;
        // collega il nuovo elemento
        p->next = q;
    }
}

int list_extract_h(LIST *l)
{
    if (l->head == 0) list_error("Empty list");
    LNODE *p = l->head;
    int tmp = p->dato;
    l->head = p->next;
    free(p);
    return tmp;
}

int list_extract_t(LIST *l)
{
}

void list_print(LIST *l)
{
    LNODE *p = l->head;
    
    printf("(");
    while (p!=0) {
        printf("%d, ", p->dato);
        p = p->next;
    }
    printf(")\n");
}
