#include <stdio.h>
#include <stdlib.h>
#include "vector.h"

struct elem {
    int x;
    int y;
};

struct elem * elem_create(int x, int y)
{
    struct elem *p = (struct elem *)malloc(sizeof(struct elem));
    p->x = x;
    p->y = y;
    return p;
}

void elem_delete(struct elem *e)
{
    free(e);
}

int main() 
{
    VECTOR_PTR vec;
    printf("Creating 10 elements and inserting them\n");
    vptr_init(&vec);
    printf("Initial size: %d\n", vptr_mem_size(&vec));
    printf("Number of elements: %d\n", vptr_num_elem(&vec));
    
    int i;
    for (i=0; i<10; i++) {
        struct elem *p = elem_create(i, i+2);
        vptr_push_back(&vec, p);
        printf("Inserted %p\n", p);
    }

    printf("Size after 10 insertions: %d\n", vptr_mem_size(&vec));
    printf("Number of elements: %d\n", vptr_num_elem(&vec));

    for (i=0; i<10; i++) {
        struct elem *p = elem_create(i+2, i);
        vptr_push_back(&vec, p);
        printf("Inserted %p\n", p);
    }
    
    printf("10 more insertions: %d\n", vptr_mem_size(&vec));
    printf("Number of elements: %d\n", vptr_num_elem(&vec));

    for (i=0; i<vptr_num_elem(&vec); i++) {
        struct elem *p = (struct elem*) vptr_elem_at(&vec, i);
        printf("Read %p\n", p);
        if (p == 0) printf("Empty!\n");
        else printf("(%d, %d)\n", p->x, p->y);
    }

    for (i=0; i<30; i++) {
        struct elem *p = (struct elem*) vptr_pop_back(&vec);
        if (p == 0) printf("Empty!\n");
        else printf("(%d, %d)\n", p->x, p->y);
        elem_delete(p);
    }
    return 0;
}
