#include <stdlib.h>
#include <memory.h>
#include "vector.h"

void vptr_init(VECTOR_PTR *v)
{
    v->array_size = 2;
    v->array = malloc(v->array_size * sizeof(void *));
    v->num_elem = 0;
}

void vptr_delete(VECTOR_PTR *v)
{
    free(v->array);
    v->array = 0;
    v->array_size = 0;
    v->num_elem = 0;
}

static void vptr_enlarge(VECTOR_PTR *v)
{
    if (v->array_size == 0) vptr_init(v);
    else v->array_size *= 2;
    void **tmp = malloc(v->array_size * sizeof(void *));
    memcpy(tmp, v->array, v->num_elem * sizeof(void *));
    free(v->array);
    v->array = tmp;
    return;
} 

void vptr_push_back(VECTOR_PTR *v, void *elem)
{
    if (v->num_elem == v->array_size) vptr_enlarge(v);
    v->array[v->num_elem++] = elem;
    return;
}

void * vptr_pop_back(VECTOR_PTR *v)
{
    if (v->num_elem == 0) return 0;
    else return v->array[--v->num_elem];
}

void * vptr_elem_at(VECTOR_PTR *v, int i)
{
    if (i >= v->num_elem) return 0;
    else return v->array[i];
}

int vptr_mem_size(VECTOR_PTR *v)
{
    return v->array_size * sizeof(void *);
}

int vptr_num_elem(VECTOR_PTR *v)
{
    return v->num_elem;
}
